/*
 * hptokdecl.h  -- An HP-2000 Timeshared BASIC System tape manipulation program.
 *
 * Copyright (c) Scott G. Taylor
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * SCOTT G. TAYLOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * Except as contained in this notice, the name of Scott G. Taylor shall not
 * be used in advertising or otherwise to promote the sale, use or other dealings
 * in this Software without prior written authorization from Scott G. Taylor.
 */

struct BASIC_Tokens {
	uint8_t		op;
	uint8_t		priority;
	char *		ascii;
};

#define Bop_ACCESS_count	0100
#define Bop_2000F_count		0100
#define Bop_2000E_count 	0100
#define	Bop_2000A_count		0100
#define Bop_2000B_count		Bop_2000A_count

#define Bop_2000C	Bop_2000F	/* HP2000C' uses the same TSB syntax as HP2000F */
#define Bop_2000B	Bop_2000A	/* HP2000B uses the same TSB syntax as HP2000A */

#define Bst_ACCESS_count 0100

#define	Bfunc_count	040
#define	BfuncTSC_count	031

#define GN_INT          0x01
#define GN_LINENO       0x02
#define GN_FLOAT        0x04

extern struct BASIC_Tokens Bop_ACCESS[];
extern struct BASIC_Tokens Bop_2000F[];
extern struct BASIC_Tokens Bop_2000E[];
extern struct BASIC_Tokens Bop_2000C_TSC[];
extern struct BASIC_Tokens Bop_2000A[];
extern struct BASIC_Tokens Bst_ACCESS[];
extern struct BASIC_Tokens Bfunc[];
extern struct BASIC_Tokens Bfunc_TSC[];

uint8_t *match_token (uint8_t *, uint32_t *, struct BASIC_Tokens *, uint32_t, uint32_t);
uint8_t *match_literal (uint8_t *, char *);
